package ru.dbotthepony.mc.otm.block;

import net.minecraft.MethodsReturnNonnullByDefault;
import net.minecraft.core.BlockPos;
import net.minecraft.core.Direction;
import net.minecraft.world.item.context.BlockPlaceContext;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.EntityBlock;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.phys.shapes.CollisionContext;
import net.minecraft.world.phys.shapes.Shapes;
import net.minecraft.world.phys.shapes.VoxelShape;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityMatterCapacitorBank;
import ru.dbotthepony.mc.otm.shapes.BlockShapes;

import javax.annotation.Nullable;
import javax.annotation.ParametersAreNonnullByDefault;
import java.util.List;

@MethodsReturnNonnullByDefault
@ParametersAreNonnullByDefault
public class BlockMatterCapacitorBank extends BlockMatteryRotatable implements EntityBlock {
	@Nullable
	@Override
	public BlockEntity newBlockEntity(BlockPos blockPos, BlockState blockState) {
		return new BlockEntityMatterCapacitorBank(blockPos, blockState);
	}

	@Nullable
	@Override
	public BlockState getStateForPlacement(BlockPlaceContext context) {
		var state = super.getStateForPlacement(context);

		for (var prop : BlockBatteryBank.BATTERY_SLOTS_PROPS)
			state = state.setValue(prop, false);

		return state;
	}

	@Override
	protected void createBlockStateDefinition(StateDefinition.Builder<Block, BlockState> builder) {
		builder.add(BlockBatteryBank.BATTERY_SLOTS_PROPS);
		super.createBlockStateDefinition(builder);
	}

	private static final List<VoxelShape> SHAPES;

	static {
		var def = BlockShapes.BATTERY_BANK.computeShape();

		SHAPES = List.of(
			def,
			def,
			def,
			BlockShapes.BATTERY_BANK.rotate(Direction.NORTH).computeShape(),
			BlockShapes.BATTERY_BANK.rotate(Direction.WEST).computeShape(),
			BlockShapes.BATTERY_BANK.rotate(Direction.EAST).computeShape()
		);
	}

	@Override
	@SuppressWarnings("deprecation")
	public VoxelShape getShape(BlockState p_60555_, BlockGetter p_60556_, BlockPos p_60557_, CollisionContext p_60558_) {
		return SHAPES.get(p_60555_.getValue(FACING).ordinal());
	}
}
