package ru.dbotthepony.mc.otm.shapes;

import net.minecraft.core.Direction;
import net.minecraft.world.phys.shapes.BooleanOp;
import net.minecraft.world.phys.shapes.Shapes;
import net.minecraft.world.phys.shapes.VoxelShape;

public record BlockShape(SimpleCuboid ...shapes) {
	public BlockShape rotateAroundY(double rad) {
		var list = new SimpleCuboid[shapes.length];

		for (int i = 0; i < shapes.length; i++)
			list[i] = shapes[i].rotateAroundY(rad);

		return new BlockShape(list);
	}

	public BlockShape rotate(Direction dir) {
		if (dir == Direction.SOUTH)
			return this;

		if (dir == Direction.NORTH)
			return rotateAroundY(Math.PI);

		if (dir == Direction.WEST)
			return rotateAroundY(-Math.PI / 2d);

		if (dir == Direction.EAST)
			return rotateAroundY(Math.PI / 2d);

		return this;
	}

	public VoxelShape computeShape() {
		VoxelShape final_shape = shapes[0].getShape();

		for (int i = 1; i < shapes.length; i++)
			final_shape = Shapes.joinUnoptimized(final_shape, shapes[i].getShape(), BooleanOp.OR);

		return final_shape;
	}
}
